package logic;

import java.util.*;

abstract public class Algorithm {
    int numConditions;
    int numRules;
    int maxNumStars;
    boolean consistencyChecking;
    
    /** use default constructor only to make polymorphism easier to implement */
    public Algorithm() {
    }
    
    public void init(int numConditions, int numRules, int maxNumStars, boolean consisChk) {
        this.numConditions = numConditions;
        this.numRules = numRules;
        this.maxNumStars = maxNumStars;
        this.consistencyChecking = consisChk;
    }
    public boolean equals(Object ob) {
        if(!(ob instanceof Algorithm) || ob == null) {
            return false;
        }
        Algorithm alg = (Algorithm)ob;
        return name().equals(alg.name());
    }
    
    public boolean getConsistencyChecking() {
        return consistencyChecking;
    }
        
        
    abstract public String name();
    
    abstract public void addRule(String boolStr, Action action) throws RuleNotFoundException,PoorPerformanceException, InconsistentRulesException ;
    
    abstract public Action lookUp(Vector results) throws RuleNotFoundException,PoorPerformanceException, InconsistentRulesException,RuleNotFoundException;
    
}