package logic;
import java.util.*;
public class RuleSequencer {
    Rules rules;
       
    /** assumes that rules is not null */
    public RuleSequencer(Rules rules) {
        this.rules = rules;
    }
   
    public void addRule(Rule rule) throws RuleNotFoundException, PoorPerformanceException, InconsistentRulesException {
        if(rules == null) {
            throw new RuleNotFoundException("Class RuleSequencer was instantiated with rules instance null");
        }        
        Action action = rule.getAction();
        ConditionValueSet set= rule.getCVS();
        char [] boolChars = new char[set.getCardinality()];
        for(set.resetIterator(); set.hasMoreElements();) {
            ConditionValue cv = (ConditionValue)set.nextElement();
            boolChars[cv.getPosition()] = cv.getValue();
        }
        String boolStr = new String(boolChars);
        rules.addRule(boolStr, action);
    }
}