package sampleCode2;
import java.util.*;
import java.net.*;
class DataBank  {
        //constants that specify a region
        static final Region EAST_REGION = new Region(Region.EAST);
        static final Region WEST_REGION = new Region(Region.WEST);
        static final Region MIDWEST_REGION = new Region(Region.MIDWEST);
        static final Region SOUTH_REGION = new Region(Region.SOUTH);
        static final Region NORTH_REGION = new Region(Region.NORTH);
        
        //limit threshold constant
        static final int LIMIT_THRESHOLD = 10000;
        
        Region region;
        double limit;
        Hashtable westMembers;
        String userId;
        
        /** 
         *  This is the version of the constructor that is used
         *  in the samples
         */
        DataBank(String userId,
                 int limit,
                 Region region) {
           initializeWestMembers();
           this.userId = userId;
           this.limit = limit;
           this.region = region;
        }
        
        DataBank(String userId,
                         int limit,
                         int regionName) {
           this(userId,limit,new Region(regionName));
        }
        
        public DataBank.Region getRegion() {
                return region;
        }
        public double getLimit() {
                return limit;
        }
        public String getUserId() {
                return userId;
        }
        public Hashtable getWestMembers() {
                return westMembers;
        }
        /**
         *  Creates the table of user id's that are to be
         *  considered members of the West Alliance
         */
        private void initializeWestMembers() {
                westMembers = new Hashtable();
                westMembers.put("0110", Boolean.TRUE);
                westMembers.put("1113", Boolean.TRUE);
                westMembers.put("3392", Boolean.TRUE);
                westMembers.put("5831", Boolean.TRUE);
        }
         
        /**
         *  Top-level inner class that encapsulate data about a region
         */
       static class Region  {
                static final int EAST = 0;
                static final int WEST = 1;
                static final int MIDWEST = 2;
                static final int NORTH = 3;
                static final int SOUTH = 4;
                int regionName;
                
                Region(int name) {
                        regionName = name;
                }
                public int getRegionName() {
                        return regionName;
                }
                
                public boolean equals(Object ob) {
                        if(!(ob instanceof DataBank.Region)) return false;
                        DataBank.Region r = (DataBank.Region)ob;
                        return (r.getRegionName() == regionName);
                }
                
        }
}                
                
                
                        
        
