package sampleCode2;

import java.util.*;
import java.net.*;
import logic.*;
import java.io.*;

class URLProcessor_good extends URLProcessor implements logic.Updateable {

        //constant used for doing update
        static final String URL_STR = "urlString";
        
        URLProcessor_good(){
                super();
        }
        
        void decideUrl() {
                try {
                    Invoker inv = new ConcreteInvoker((Updateable)this);
                    inv.init();
                    inv.execute();
                }
                catch(PoorPerformanceException ppe) {
                    //handle
                    System.out.println(ppe.getMessage());
                }
                
                catch(IllegalExpressionException iee) {
                    //handle
                    System.out.println(iee.getMessage());
                }
                
                catch(RuleNotFoundException rnfe) {
                    //handle
                    System.out.println(rnfe.getMessage());
                }
                
                catch(DataNotFoundException dnfe) {
                    //handle
                    System.out.println(dnfe.getMessage());
                }
                catch(InconsistentRulesException ire) {
                    //handle
                    System.out.println(ire.getMessage());
                }
        }
        
        /** Updateable interface implementation */
        public void doUpdate(Hashtable ht) {
                if(ht == null) return;
                Object ob = ht.get(Action.MAIN_KEY);
                if(ob != null && ob instanceof String) {
                    setUrl((String)ob);
                }
        }

        static class OtherCondition extends Condition {
                public static final String KEY = "key";
                public OtherCondition(Hashtable ht) {
                        super(ht);
                }
                public Boolean evaluate() throws DataNotFoundException {
                        Object ob = null;
                        if(getData() == null || (ob = getData().get(KEY)) == null) {
                                throw new DataNotFoundException();
                        }
                        if(!(ob instanceof DataBank.Region)) {
                                return Boolean.FALSE;
                        }
                        DataBank.Region region = (DataBank.Region)ob;
                        boolean result = !region.equals(DataBank.WEST_REGION) &&
                                                         !region.equals(DataBank.EAST_REGION);
                        return new Boolean(result);
                }
                        
                        
        }
        

        static class MemberCondition extends Condition {
            public static final String KEY = "id";
            public static final String TABLE = "table";
            
            /** 
             *  The argument ht should have KEY matched with user id and
             *  TABLE matched with westMember hashtable
             */
            public MemberCondition(Hashtable ht) {
                super(ht);
            }
            public Boolean evaluate() throws DataNotFoundException {
                Object id = null, table = null;
                if(getData() == null || ((id = getData().get(KEY)) == null) || 
                    ((table = getData().get(TABLE))==null) ||
                    !(table instanceof Hashtable)) {
                                   
                        throw new DataNotFoundException();
                                   
                }                                
                Hashtable members = (Hashtable)table;
                return new Boolean(members.containsKey(id));
            }
        }
        public interface OrderOfEvaluation {
            final int EAST_CONDITION  = 0;
            final int WEST_CONDITION  = 1;
            final int OTHER_CONDITION = 2;
            final int LIMIT_CONDITION = 3;
            final int MEMBER_CONDITION= 4;
            
        }
        
        public class ConcreteInvoker extends Invoker implements OrderOfEvaluation {
            final int numConditions = 5;
            final int numRules = 7;
            final int maxNumStars = 2;
            public ConcreteInvoker(Updateable ud) throws PoorPerformanceException {
                super(ud);
            }            public void loadRules() throws InconsistentRulesException, 
                                           PoorPerformanceException, 
                                           RuleNotFoundException {
                
                Algorithm alg = (Algorithm)Util.getInstance(Algorithm_fewStars.NAME);
                Boolean checkConsis = Boolean.TRUE;
                rules = new Rules(numConditions,numRules,maxNumStars,null,checkConsis);
                //rules = new Rules(numConditions,numRules,maxNumStars);
                RuleSequencer sequencer = new RuleSequencer(rules);
                try {
                
                    //add rule TFFT*, EAST_PRIVILEGED
                    ConditionValueSet cvs_eastPriv = new ConditionValueSet();
                    cvs_eastPriv.addMember(new ConditionValue(EAST_CONDITION,'T'));
                    cvs_eastPriv.addMember(new ConditionValue(WEST_CONDITION,'F'));
                    cvs_eastPriv.addMember(new ConditionValue(OTHER_CONDITION,'F'));
                    cvs_eastPriv.addMember(new ConditionValue(LIMIT_CONDITION,'T'));
                    cvs_eastPriv.addMember(new ConditionValue(MEMBER_CONDITION,'*'));
                    sequencer.addRule(new Rule(cvs_eastPriv, new Action(ud,EAST_PRIVILEGED)));

                
                    //add rule TFFF*, EAST_NOT_PRIVILEGED
                    ConditionValueSet cvs_eastNonPriv = new ConditionValueSet();
                    cvs_eastNonPriv.addMember(new ConditionValue(EAST_CONDITION,'T'));
                    cvs_eastNonPriv.addMember(new ConditionValue(WEST_CONDITION,'F'));
                    cvs_eastNonPriv.addMember(new ConditionValue(OTHER_CONDITION,'F'));
                    cvs_eastNonPriv.addMember(new ConditionValue(LIMIT_CONDITION,'F'));
                    cvs_eastNonPriv.addMember(new ConditionValue(MEMBER_CONDITION,'*'));
                    sequencer.addRule(new Rule(cvs_eastNonPriv, new Action(ud,EAST_NOT_PRIVILEGED)));

                    //add rule FTFTT, WEST_MEMBER_PRIVILEGED
                    ConditionValueSet cvs_westMemPriv = new ConditionValueSet();
                    cvs_westMemPriv.addMember(new ConditionValue(EAST_CONDITION,'F'));
                    cvs_westMemPriv.addMember(new ConditionValue(WEST_CONDITION,'T'));
                    cvs_westMemPriv.addMember(new ConditionValue(OTHER_CONDITION,'F'));
                    cvs_westMemPriv.addMember(new ConditionValue(LIMIT_CONDITION,'T'));
                    cvs_westMemPriv.addMember(new ConditionValue(MEMBER_CONDITION,'T'));
                    sequencer.addRule(new Rule(cvs_westMemPriv, new Action(ud,WEST_MEMBER_PRIVILEGED)));
                
                    //add rule FTFTF, WEST_NONMEMBER_PRIVILEGED
                    ConditionValueSet cvs_westNonMemPriv = new ConditionValueSet();
                    cvs_westNonMemPriv.addMember(new ConditionValue(EAST_CONDITION,'F'));
                    cvs_westNonMemPriv.addMember(new ConditionValue(WEST_CONDITION,'T'));
                    cvs_westNonMemPriv.addMember(new ConditionValue(OTHER_CONDITION,'F'));
                    cvs_westNonMemPriv.addMember(new ConditionValue(LIMIT_CONDITION,'T'));
                    cvs_westNonMemPriv.addMember(new ConditionValue(MEMBER_CONDITION,'F'));
                    sequencer.addRule(new Rule(cvs_westNonMemPriv, new Action(ud,WEST_NONMEMBER_PRIVILEGED)));

                    //add rule FTFFF, WEST_MEMBER_NOT_PRIVILEGED
                    ConditionValueSet cvs_westMemNotPriv = new ConditionValueSet();
                    cvs_westMemNotPriv.addMember(new ConditionValue(EAST_CONDITION,'F'));
                    cvs_westMemNotPriv.addMember(new ConditionValue(WEST_CONDITION,'T'));
                    cvs_westMemNotPriv.addMember(new ConditionValue(OTHER_CONDITION,'F'));
                    cvs_westMemNotPriv.addMember(new ConditionValue(LIMIT_CONDITION,'F'));
                    cvs_westMemNotPriv.addMember(new ConditionValue(MEMBER_CONDITION,'T'));
                    sequencer.addRule(new Rule(cvs_westMemNotPriv, new Action(ud,WEST_MEMBER_NOT_PRIVILEGED)));
                
                    //add rule FTFFF, WEST_NONMEMBER_NOT_PRIVILEGED
                    ConditionValueSet cvs_westNonMemNotPriv = new ConditionValueSet();
                    cvs_westNonMemNotPriv.addMember(new ConditionValue(EAST_CONDITION,'F'));
                    cvs_westNonMemNotPriv.addMember(new ConditionValue(WEST_CONDITION,'T'));
                    cvs_westNonMemNotPriv.addMember(new ConditionValue(OTHER_CONDITION,'F'));
                    cvs_westNonMemNotPriv.addMember(new ConditionValue(LIMIT_CONDITION,'F'));
                    cvs_westNonMemNotPriv.addMember(new ConditionValue(MEMBER_CONDITION,'F'));
                    sequencer.addRule(new Rule(cvs_westNonMemNotPriv, new Action(ud,WEST_NONMEMBER_NOT_PRIVILEGED)));

                    //add rule FFT**, OTHER_REGION
                    ConditionValueSet cvs_other = new ConditionValueSet();
                    cvs_other.addMember(new ConditionValue(EAST_CONDITION,'F'));
                    cvs_other.addMember(new ConditionValue(WEST_CONDITION,'F'));
                    cvs_other.addMember(new ConditionValue(OTHER_CONDITION,'T'));
                    cvs_other.addMember(new ConditionValue(LIMIT_CONDITION,'*'));
                    cvs_other.addMember(new ConditionValue(MEMBER_CONDITION,'*'));
                    sequencer.addRule(new Rule(cvs_other, new Action(ud,OTHER_REGION)));
                }                
                
                catch(PoorPerformanceException e) {
                    throw e;
                }
                catch(RuleNotFoundException e) {
                    throw e;
                }
                                        
            }
                
            public void loadConditions() throws IllegalExpressionException, RuleNotFoundException{
                try {  
                    conditions = new Vector(numConditions);
                    ConditionSequencer sequencer = new ConditionSequencer(conditions);
                    sequencer.addCondition(new Condition(db.getRegion(),DataBank.EAST_REGION), 
                                           EAST_CONDITION);
                    sequencer.addCondition(new Condition(db.getRegion(),DataBank.WEST_REGION),
                                           WEST_CONDITION);
                        
                    Hashtable other = new Hashtable();
                    other.put(OtherCondition.KEY,db.getRegion());
                    sequencer.addCondition(new OtherCondition(other), OTHER_CONDITION);
                        
                    sequencer.addCondition(new Condition(db.LIMIT_THRESHOLD, Condition.LESS,db.getLimit() ),
                                           LIMIT_CONDITION);                         
                        
                    Hashtable mem = new Hashtable();
                    mem.put(MemberCondition.TABLE, db.getWestMembers());
                    mem.put(MemberCondition.KEY, db.getUserId());
                    sequencer.addCondition(new MemberCondition(mem), MEMBER_CONDITION);
                }
                catch(IllegalExpressionException e) {
                    throw e;
                }
                catch(RuleNotFoundException e) {
                    throw e;
                }
            }
        }
        /**
         *  This main method lets you run the sample code as an application
         *  with no GUI. The output is displayed in standard output.
         */
        public static void main(String [] args) {
                DataBank db = new DataBank("0110", 5000, DataBank.Region.WEST);
                URLProcessor urlp = new URLProcessor_good();
                urlp.setDb(db);
                urlp.decideUrl();
                System.out.println("URL for this user is "+urlp.url);
                try {
                    System.in.read();
                }
                catch(Exception e) {}
        } 
                
                
}

